<template>
    <div class="wrap" ref="wrap">
        <p class="stopwatch">{{reactionTime}} <span>ms</span></p>
        <img class="block" 
        ref="icon"
        width="80px"
        alt="icon corruptor"
        :src="require(`@/assets/tikus.png`)"
        @click.self="playSound();stopTimer()" 
        :style="styleRandom" 
        v-if="showBlock"/>
    </div>
</template>
<script>
import SlapSound from "../assets/slap.mp3"

export default {
    props : ['delay'],
    data() {
        return {
            elapsedTime: 0,
            showBlock : false,
            timer : null,
            reactionTime : 0 , 
            styleRandom : {
                top  :  null ,
                left :  null
            },
        }
    },
     async mounted() {
         await this.$nextTick()
            const {
                clientWidth: mainWidth,
                clientHeight: mainHeight,
            } = this.$refs.wrap;
            this.styleRandom.top =Math.random() * (mainHeight -80 ) + "px";
            this.styleRandom.left = Math.random() * (mainWidth - 80) + "px"; 
        
        setTimeout(() => {
            this.showBlock = true
            this.startTimer()
        }, this.delay);
    },
    computed: {
        formattedElapsedTime() {
            const date = new Date(null);
            date.setSeconds(this.elapsedTime / 1000);
            const utc = date.toUTCString();
            return utc.substr(utc.indexOf(":") - 2, 8);
        }
    },
    methods: {
        startTimer(){
            this.timer = setInterval(() => {
                this.reactionTime += 10    
            }, 10);
            this.elapsedTime = 0;
            this.timer = setInterval(() => {
                this.elapsedTime += 1000;
            }, 1000);
        },
        stopTimer(){
            clearInterval(this.timer)
            this.$emit('end', this.reactionTime)
        },
        playSound() {
            let audio = new Audio(SlapSound);
            audio.play();
        }
    },
}
</script>

<style>
    .wrap{
        height: 50vh;
        width: auto;
        position: relative;
    }
    .wrap .stopwatch{
        font-weight: 600;
        font-size: 15pt;
        color :#2c3e50;
    }
    .stopwatch span{
        font-weight: 100;
    }
    .block{
        width: 80px;
        border-radius: 50px;
        cursor: grab;
        position: absolute;
    }
</style>